#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_usart.h"
#include "stm32f10x_i2c.h"
#include "stm32f10x_tim.h"
#include "delay.h"
#include "str.h"

#include "I2C.h"    //     I2C
#include "LCD_I2C.h"

//  http://www.useto.ru/index.php/component/content/article/255-SSD1306-R-STM32F103CBT6-Maple-Mini

#define TIMER_PRESCALER	1000

//    
GPIO_InitTypeDef PORT;
TIM_TimeBaseInitTypeDef timer;

uint16_t previousState;    //     

int counter,a0,a1,a2,a3;   //   

void main()
{
  uint8_t data;

  //   PB1
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
  PORT.GPIO_Pin = GPIO_Pin_1 ;
  PORT.GPIO_Mode = GPIO_Mode_Out_PP;
  PORT.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init( GPIOB , &PORT);

  //   PB8
  PORT.GPIO_Pin =  GPIO_Pin_8  ;
  PORT.GPIO_Mode = GPIO_Mode_IPD;
  PORT.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_Init(GPIOB, &PORT);

  /*
   * GPIO_Mode_AIN   .
	GPIO_Mode_IN_FLOATING    .
	GPIO_Mode_IPD      .
	GPIO_Mode_IPU      .
	GPIO_Mode_Out_OD     .
	GPIO_Mode_Out_PP    .
	GPIO_Mode_AF_OD      .
	GPIO_Mode_AF_PP     .
   *
   */

   //    TIM4
   // 4      APB1
   RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);
  //   
  //    
   TIM_TimeBaseStructInit(&timer);
      // 
   timer.TIM_Prescaler = TIMER_PRESCALER;
      // ,      
      //       
   timer.TIM_Period = 1000;
      // TIM4  
      TIM_TimeBaseInit(TIM4, &timer);
      __enable_irq();    //  

  init_I2C1();    //  i2
  Delay(50);
  LCDI2C_init();   //  ,  0x78  
  LCDI2C_clear();  //    
  LCD_X = 0;
  LCD_Y = 0;
  counter = 0;
  //       ()
  	    TIM_ITConfig(TIM4, TIM_IT_Update, ENABLE);
  	    // 
  	    TIM_Cmd(TIM4, ENABLE);
  	    //  
  	    NVIC_EnableIRQ(TIM4_IRQn);
  	    while(1)
  	    {
  		//      
  	    	if(GPIO_ReadInputDataBit (GPIOB, GPIO_Pin_8)){  //  
  	    		NVIC_DisableIRQ(TIM4_IRQn);   //  
  	    		LCDI2C_clear();
      		   GPIO_SetBits(GPIOB, GPIO_Pin_1);
  	    		if (previousState==0){
  	    			previousState = 1;
  	    			GPIO_SetBits(GPIOB, GPIO_Pin_1);
  	    		}else {
  	    			previousState = 0;
  	    			GPIO_ResetBits(GPIOB, GPIO_Pin_1);
  	    		}
  	    		Delay(500);
  	    		NVIC_EnableIRQ(TIM4_IRQn);   //  
  	    	}

  		__NOP();
  	    }
  return;
}

void TIM4_IRQHandler()    //   
{
    //  
	counter++;

	if (counter>9999){
	  counter=0;
	}

	char buf[5];
	itoa(counter,buf,10);   //    ,   

    if (previousState !=1 ) //       
    {   //  
		GPIO_SetBits(GPIOB, GPIO_Pin_1);    //  
		//   
		//  0000  9999
	    a0 = 0;
		a1 = 0;
		a2 = 0;
		a3 = 0;

	    if (strlen(buf)==1){
	    	a0= buf[0]-48;
	    }
	    if (strlen(buf)==2){
		    a0 = buf[1]-48;
			a1 = buf[0]-48;
	    }
	    if (strlen(buf)==3){
		    a0 = buf[2]-48;
			a1 = buf[1]-48;
		    a2 = buf[0]-48;
	    }
	    if (strlen(buf)==4){
		    a0 = buf[3]-48;
			a1 = buf[2]-48;
		    a2 = buf[1]-48;
		    a3 = buf[0]-48;
	    }

		LCDI2C_bigprint(0,a3);   //    
		LCDI2C_bigprint(4,a2);
		LCDI2C_bigprint(9,a1);
		LCDI2C_bigprint(13,a0);
		LCDI2C_refresh();
		timer.TIM_Period = 1000;
		TIM_TimeBaseInit(TIM4, &timer);
    }
    else
    {
	//   
    // 
	GPIO_ResetBits(GPIOB, GPIO_Pin_1);
    LCDI2C_Print("test: ");  //    
	LCDI2C_Printf(buf);   //    

	timer.TIM_Period = 20000;   //      
	TIM_TimeBaseInit(TIM4, &timer);
    }
    //  
   	TIM_ClearITPendingBit(TIM4, TIM_IT_Update);
}

